/*********************************************************************/
/*                                                                   */
/*  This Program Written by Paul Edwards.                            */
/*  Released to the public domain                                    */
/*                                                                   */
/*********************************************************************/
/*********************************************************************/
/*                                                                   */
/*  objfill - convert output of initobj into filler statements       */
/*                                                                   */
/*

The output of INITOBJ looks like this:

 1 INITOBJ - Uninitialized Areas Page No.   1
   Csect    Rel Addr(hex) Length(dec)
   IEBGENER    0003AA          2
   IEBGENER    0003FE          2
   IEBGENER    000405         83

and it needs to look like this:

FILLER   0003AA    0003AB
FILLER   0003FE    0003FF
FILLER   000405    000457

*/
/*                                                                   */
/*********************************************************************/

#include <stdio.h>
#include <string.h>
#include <ctype.h>

static char buf[300];

int main(void)
{
    int start;
    int len;

    while (fgets(buf, sizeof buf, stdin) != NULL)
    {
        if (strlen(buf) > 20)
        {
            if (isdigit((unsigned char)buf[14]))
            {
                sscanf(buf, "%*s %x %d", &start, &len);
                printf("FILLER   %06X    %06X\n", start, start + len - 1);
            }
        }
    }
    return (0);
}
